%This script runs the SOC PID control model and plots results
close all
clear
clc

%Load parameters necessary to run simulation
%This includes battery parameters and operating points/maps found in the
%optimization script from Module 3

load('Initialize.mat')

t_end=2500;    %Simulation time (s)

P_tractive=30e3;  %Tractive motor power (W)

SOC_init=20;  %Initial SOC
SOC_ref=10;   %Target SOC

%PID Control parameters
Kp=110;    %Proportinal Gain
Ki=2.5;    %Integral Gain
Kd=0;      %Derivative Gain

sim('SOC_PID')

%Plot significant results
figure
plot(time,SOC)
title('SOC Using PID Control')
xlabel('Time (s)')
ylabel('SOC')

figure
plot(time,P_req)
title('Power Requested by PID Controller')
xlabel('Time (s)')
ylabel('Torque (Nm)')

figure
plot(time,T_req)
title('Engine Torque Requested by PID Controller')
xlabel('Time (s)')
ylabel('Torque (Nm)')

figure
plot(time,N_req)
title('Generator Speed Requested by PID Controller')
xlabel('Time (s)')
ylabel('Speed (RPM)')

figure
plot(time,T_eng)
title('Actual Engine Torque')
xlabel('Time (s)')
ylabel('Torque (Nm)')

figure
plot(time,N_gen)
title('Actual Generator Speed')
xlabel('Time (s)')
ylabel('Speed (RPM)')