%This script runs the SOC PID and FF control model and plots results
close all
clear
clc

%Load parameters necessary to run simulation
%This includes battery parameters and operating points/maps found in the
%optimization script from Module 3

load('Initialize.mat')

t_end=2500;        %Simulation time (s)

P_tractive=30e3;   %Tractive Motor Power (W)

SOC_init=20;  %Initial SOC
SOC_ref=10;   %Target SOC

I_error=.75;       %Error in motor Power estimation

%PID Gains
Kp=110;
Ki=2.5;
Kd=0;

sim('SOC_PIDandFF')

%Plot important figures
figure
plot(time,SOC)
title('SOC Using PID Control')
xlabel('Time (s)')
ylabel('SOC')

figure
plot(time,T_req)
title('Engine Torque Requested by PID and FF Controller')
xlabel('Time (s)')
ylabel('Torque (Nm)')

figure
plot(time,N_req)
title('Generator Speed Requested by PID and FF Controller')
xlabel('Time (s)')
ylabel('Speed (RPM)')

figure
plot(time,T_eng)
title('Actual Engine Torque')
xlabel('Time (s)')
ylabel('Torque (Nm)')

figure
plot(time,N_gen)
title('Actual Generator Speed')
xlabel('Time (s)')
ylabel('Speed (RPM)')

figure
plot(time,P_req)
title('Total Power Request by PID and FF Controller')
xlabel('Time (s)')
ylabel('Power (kW)')

figure
plot(time,P_reqPID)
title('Power Request by PID Controller')
xlabel('Time (s)')
ylabel('Power (kW)')

figure
plot(time,P_reqFF)
title('Power Request by FF Controller')
xlabel('Time (s)')
ylabel('Power (kW)')